/**
 * ENXP.java
 *
 * File generated from the datatypes::ENXP uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.ips.datatypes;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class ENXP.
 *
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ENXP", propOrder = {
	"partType",
	"qualifier"
})
@XmlRootElement(name = "ENXP")
public class ENXP extends net.ihe.gazelle.ips.datatypes.ST implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	/**
	 *  Indicates whether the name part is a given name, family name, prefix, suffix, etc. .
	 */
	@XmlAttribute(name = "partType")
	public net.ihe.gazelle.voc.EntityNamePartType partType;
	/**
	 *  The qualifier is a set of codes each of which specifies a certain subcategory of the name part in addition to the main name part type. For example, a given name may be flagged as a nickname, a family name may be a pseudonym or a name of public records. .
	 */
	@XmlAttribute(name = "qualifier")
	public List<String> qualifier;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private Node _xmlNodePresentation;
	
	
	/**
	 * Return partType.
	 * @return partType :  Indicates whether the name part is a given name, family name, prefix, suffix, etc. 
	 */
	public net.ihe.gazelle.voc.EntityNamePartType getPartType() {
	    return partType;
	}
	
	/**
	 * Set a value to attribute partType.
	 * @param partType :  Indicates whether the name part is a given name, family name, prefix, suffix, etc. .
	 */
	public void setPartType(net.ihe.gazelle.voc.EntityNamePartType partType) {
	    this.partType = partType;
	}
	
	
	
	
	/**
	 * Return qualifier.
	 * @return qualifier :  The qualifier is a set of codes each of which specifies a certain subcategory of the name part in addition to the main name part type. For example, a given name may be flagged as a nickname, a family name may be a pseudonym or a name of public records. 
	 */
	public List<String> getQualifier() {
		if (qualifier == null) {
	        qualifier = new ArrayList<String>();
	    }
	    return qualifier;
	}
	
	/**
	 * Set a value to attribute qualifier.
	 * @param qualifier :  The qualifier is a set of codes each of which specifies a certain subcategory of the name part in addition to the main name part type. For example, a given name may be flagged as a nickname, a family name may be a pseudonym or a name of public records. .
	 */
	public void setQualifier(List<String> qualifier) {
	    this.qualifier = qualifier;
	}
	
	
	
	/**
	 * Add a qualifier to the qualifier collection.
	 * @param qualifier_elt Element to add.
	 */
	public void addQualifier(String qualifier_elt) {
	    this.getQualifier().add(qualifier_elt);
	}
	
	/**
	 * Remove a qualifier to the qualifier collection.
	 * @param qualifier_elt Element to remove
	 */
	public void removeQualifier(String qualifier_elt) {
	    this.getQualifier().remove(qualifier_elt);
	}
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.ips.datatypes");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "ENXP").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	
	/**
	 * Description of the method cdaEquals.
	 *
	 * @param enxp1
	 * @return ret
	 */
	public Boolean cdaEquals(net.ihe.gazelle.ips.datatypes.ENXP enxp1) {
		Boolean res = true;
		if (partType != enxp1.partType)
			return false;
		if (qualifier == null) {
			if (enxp1.qualifier != null)
				return false;
		} else if (!qualifier.equals(enxp1.qualifier))
			return false;
		if (!this.getListStringValues().equals(enxp1.getListStringValues())){
			return false;
		}
		return res;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ENXP other = (ENXP) obj;
		return this.cdaEquals(other);
	}

	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(ENXP eNXP, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (eNXP != null){
   			net.ihe.gazelle.ips.datatypes.ST.validateByModule(eNXP, _location, cvm, diagnostic);
    	}
    }

}